#define ID_G3D 0x13332666

//-- G3D file format structures ---------------------------------------------
typedef struct {
   int conf,flags,versao,texttype;
   int tex_start,obj_start,lvl_start;
   int texts,objs,levels,players;
} G3D_Header;

typedef struct {
   short xsize,ysize,flags;
} Gtexture_Header;

typedef struct {
   char nome[33];
   unsigned char paleta[256][3];
   int objs,flags,lights;
   vertice_3d inipos;
   dir inidir;
} Glevel_Header;

typedef struct {
   int verts,faces,flags;
   float max_raio, mid_raio;
} Gobject_Header;

typedef struct {
   short pflags,tflags,cor[20];
   vertice_3d initpos;
   dir initdir,initrot;
} Glevel_Obj;

typedef struct {
   short cor,p1,p2,p3,tx1,ty1,tx2,ty2,tx3,ty3,txn,midz,culled;
} Gface_H;

typedef struct {
   float x,y,z;
   float rx,ry,rz;
   int px,py;
} Gvertex_H;

//-- Function Prototypes ----------------------------------------------------

int Init_G3D(char *name);
void Fecha_G3D(void);
level *Load_Level(int level);
object_3d *Load_Object(void);
