#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <math.h>
#include <time.h>

#pragma option -3

#include "gfly.h"
#include "g3d.h"

struct {
  int x,y;
} p[3];

struct {
  int x,y,tx,ty;
} tp[3];

struct Tedge {
  int x,u,v;
};

void Smooth(int xi, int yi, int xf, int yf);
void memcopy(int source, int dest);
void plot(int x, int y, int color);
void cls(int color);
int point(int x, int y);
void Poly(int x1,int y1,int x2,int y2,int x3,int y3,int c);
void Tpoly(int x1,int y1,int tx1,int ty1,int x2,int y2,int tx2,int ty2,int x3,int y3,int tx3,int ty3,int tnx);
void scan(int xi, int yi, int xf, int yf, int e);
void Tscan(int xi, int yi,int txi, int tyi, int xf, int yf,int txf, int tyf, int e);
void HLine(int y, int xi, int xf, unsigned char col);
void THLine(int y, int xi, int xf, int txi, int tyi, int mtx, int mty);
void plotasm(int x, int y, unsigned char col);
void setmode(int mode);
void setVGApalette(unsigned char *buffer);
int loadbmp (char file_name[]);

union REGS regs;
struct SREGS inreg;

unsigned char Pal_Array[256][3];
int active_bank,bank,edge1[200],edge2[200];
long xres,yres;
unsigned char Virtual[160][100],VrtBack[80][60];
Tedge Tedge1[200], Tedge2[200];
char textable[24576];

int main(void)
{
   int mid, t, x,y,c,rb,gb,bb;

  G3D_Header g3d;
  Glevel_Header lvl;
  Gobject_Header obj;
  Gface_H face[12];
  Gvertex_H vertex[8];
  FILE *f;
  printf("Lendo dados de teste.g3d:\n");
  f=fopen("teste.g3d", "rb");
  fread(&g3d, sizeof(g3d), 1, f);
  printf("Conf: ");
  if(g3d.conf!=0x2666) { printf("Erro."); return 1; } else printf("OK.");
  printf("  Verso: %d\n", g3d.versao);
  printf("Texturas: %d  Objetos: %d  Levels: %d  Jogadores: %d\n", g3d.texts, g3d.objs, g3d.levels, g3d.players);

  fread(&textable[0],24576,1,f);
  fread(&lvl, sizeof(lvl),1,f);
  fread(&obj,sizeof(obj),1,f);
  fread(&face[1], sizeof(face[1]),12,f);
  fread(&vertex[1], sizeof(vertex[1]),8,f);
  fclose(f);

  printf("\nPressione T para ver as texturas, ou qualquer tecla para comear");
  char a=getch();

  setmode(0x13);
  setVGApalette(&lvl.paleta[0][0]);

  if((a==84)||(a==116)) {

  for(y=0;y<64;y++)
    for(x=0;x<64;x++) {
      plotasm(x,y,textable[y*64+x]);
      plotasm(x+70,y,textable[(y*64+x)+4096]);
      plotasm(x+140,y,textable[(y*64+x)+8192]);
      plotasm(x,y+70,textable[(y*64+x)+12288]);
      plotasm(x+70,y+70,textable[(y*64+x)+16384]);
      plotasm(x+140,y+70,textable[(y*64+x)+20480]);
    }

  getch();
  }

   loadbmp("fundo.bmp");
   for(y=0;y<100;y++)
     for(x=0;x<160;x++)
       Virtual[x][y]=point(x,y);

   for(y=20;y<80;y++)
     for(x=40;x<120;x++)
       VrtBack[x-40][y-20]=point(x,y);

   struct {
     float x, y, z;
   } olho;
   int odp[12];
   float seno[450]; //cos(x)=sin(x+90)
   for(int ang=0;ang<451;ang++) seno[ang] = sin(ang*.0175);

   olho.x = 0; olho.y = 0; olho.z = -240;
   int v, exit=0,dx=2,dy=2,dz=2;
   int ax=0,ay=0,az=0,inch;
   int maxx,maxy,midx,midy;
   maxx = 160; midx = 80;
   maxy = 100; midy = 50;
   int tdx=1, tdy=-1, tlx=0, tly=0, move=0;

   do {
   if(move==1) {
   if((tlx+tdx<0)||(tlx+tdx>160)) tdx=0-tdx;
   if((tly+tdy<0)||(tly+tdy>100)) tdy=0-tdy;
   tlx+=tdx; tly+=tdy;
   }

   for(y=0;y<100;y++)
     for(x=0;x<160;x++)
       plotasm(x,y,Virtual[x][y]);

   for(y=20;y<80;y++)
     for(x=40;x<120;x++)
       Virtual[x][y]=VrtBack[x-40][y-20];

   if (kbhit()) inch = getch();

   if (inch==43) olho.z=olho.z+10;
   if(olho.z>100) olho.z = 100;
   if (inch==45) olho.z=olho.z-10;
   if(olho.z<-1000) olho.z = -1000;

   if (inch==97) dx++;
   if(dx>30) dx = 30;
   if (inch==100) dx--;
   if(dx< -30) dx = -30;

   if (inch==119) dy++;
   if(dy>30) dy = 30;
   if (inch==120) dy--;
   if(dy<-30) dy = -30;

   if (inch==113) dz++;
   if(dz>30) dz = 30;
   if (inch==115) dz--;
   if(dz<-30) dz = -30;

   if (inch==27) exit=1;

   inch=0;

   ax=(ax+dx)%360;
   if(ax<0) ax = 360 + ax;
   ay=(ay+dy)%360;
   if(ay<0) ay = 360 + ay;
   az=(az+dz)%360;
   if(az<0) az = 360 + az;

   for(v=1;v<9;v++)
   {
     float tmpx, tmpy;
     float tx, ty, tz;
     float s1, c1, s2, c2, s3, c3;

     s1 = seno[ax]; c1 = seno[ax+90];
     s2 = seno[ay]; c2 = seno[ay+90];
     s3 = seno[az]; c3 = seno[az+90];

     tx = vertex[v].x * c1 - vertex[v].z * s1;
     tz = vertex[v].x * s1 + vertex[v].z * c1;
     vertex[v].rz = tz * c3 - vertex[v].y * s3;
     ty = tz * s3 + vertex[v].y * c3;
     vertex[v].rx = tx * c2 + ty * s2;
     vertex[v].ry = ty * c2 - tx * s2;

     vertex[v].rx = vertex[v].rx - olho.x;
     vertex[v].ry = vertex[v].ry - olho.y;
     vertex[v].rz = vertex[v].rz - olho.z;
     tmpx=((vertex[v].rx / vertex[v].rz) * maxx)*.82+ midx;
     tmpy=(vertex[v].ry / vertex[v].rz) * maxy + midy;
     vertex[v].px = ceil(tmpx);
     vertex[v].py = ceil(tmpy);
   };

   for(int f=1;f<13;f++)
   {
    face[f].midz=(vertex[face[f].p1].rz+vertex[face[f].p2].rz+vertex[face[f].p3].rz)/3;
    odp[f] = f;
   }

   int tmp, ctr1, ctr2;
   for(ctr1=1;ctr1<13;ctr1++)
     for(ctr2=ctr1+1;ctr2<13;ctr2++) {
       if(face[ctr1].midz > face[ctr2].midz) {
	 tmp = face[ctr1].midz;
	 face[ctr1].midz = face[ctr2].midz;
	 face[ctr2].midz = tmp;
	 tmp = odp[ctr1];
	 odp[ctr1] = odp[ctr2];
	 odp[ctr2] = tmp;
       }
     }

   int visible, poly[6],q;
   for(int ff=1;ff<13;ff++)
   {
      f = 13 - odp[ff];
      poly[0] = vertex[face[f].p1].px;
      poly[1] = vertex[face[f].p1].py;
      poly[2] = vertex[face[f].p2].px;
      poly[3] = vertex[face[f].p2].py;
      poly[4] = vertex[face[f].p3].px;
      poly[5] = vertex[face[f].p3].py;

      visible = (poly[4] - poly[0]) * (poly[3] - poly[1]) - (poly[2] - poly[0]) * (poly[5] - poly[1]);
      if (visible < -100) Tpoly(poly[0],poly[1],face[f].tx1,face[f].ty1,poly[2],poly[3],face[f].tx2,face[f].ty2,poly[4],poly[5],face[f].tx3,face[f].ty3,face[f].txn);
    }
   } while(exit==0);

   setmode(0x3);
   printf("G Soft Produes\n\nVetores 3D com Back Face Culling\n\nMande suas dvidas, comentrios ou doaes para:\ncrash_neth@lords.com\n\nGS copyright 1999\n");

   return 0;
}

int loadbmp (char file_name[])
{
  #include <dos.h>
  #include <stdio.h>

  FILE *f1;
  unsigned char ch,ch1,r,g,b,color,line_length,end;
  int line_end,i,j,k,m,pass,x1,y1,x2,y2;

  if((f1=fopen(file_name,"rb"))==NULL)
  {
     printf("Digite um arquivo que exista!");
     return(1);
  }
  else
  {
     ch=fgetc(f1);
     ch1=fgetc(f1);
     if((ch!=0x42) || (ch1!=0x4D))
     {
	printf("\nO arquivo %c no  um BMP vlido.\n", file_name);
	fclose(f1);
	return(1);
     }
  }
  fseek(f1,54L,SEEK_SET);
  for(i=0;i<256;i++)
  {
     for(j=2;j>-1;j--)
     {
       Pal_Array[i][j]=fgetc(f1);
       Pal_Array[i][j]=Pal_Array[i][j] / 4;
     }
     ch=fgetc(f1);
  }

  setmode(0x13);
  setVGApalette(&Pal_Array[0][0]);

  for(k=199;k>-1;k--)
    for(i=0;i<320;i++)
    {
      ch1=fgetc(f1);
      plotasm(i,k,ch1);
    }

  fclose(f1);
  return(0);
}


void Smooth(int xi, int yi, int xf, int yf)
{
  int y,x,midp,v1,v2,v3,v4;

  for(y=yi;y<yf;y++)
   for(x=xi;x<xf;x++)
   {
    if(x!=0) v1=point(x-1,y); else v1=0;
    if(y!=0) v2=point(x,y-1); else v2=0;
    if(x!=319) v3=point(x+1,y); else v3=0;
    if(y!=199) v4=point(x,y+1); else v4=0;
    midp=(v1+v2+v3+v4)/4-1;
    if(midp<0) midp=0;
    plotasm(x,y,midp);
   }
}


void Poly(int x1,int y1,int x2,int y2,int x3,int y3,int c)
{
  int min,mid,max,y,xi,xf,tmp;
  p[0].x=x1; p[0].y=y1;
  p[1].x=x2; p[1].y=y2;
  p[2].x=x3; p[2].y=y3;

  if(p[0].y<p[1].y) min=0; else min=1;
  if(p[2].y<p[min].y) min=2;
  if(p[0].y>p[1].y) max=0; else max=1;
  if(p[2].y>p[max].y) max=2;
  mid=3-min-max;

  scan(p[min].x,p[min].y,p[max].x,p[max].y,1);
  scan(p[min].x,p[min].y,p[mid].x,p[mid].y,2);
  scan(p[mid].x,p[mid].y,p[max].x,p[max].y,2);

  for(y=p[min].y;y<p[max].y;y++) {
    if (edge1[y]<edge2[y]) {
      xi=edge1[y];
      xf=edge2[y];
    } else {
      xi=edge2[y];
      xf=edge1[y];
    }
    HLine(y,xi,xf,c);
  }

}

void Tpoly(int x1,int y1,int tx1,int ty1,int x2,int y2,int tx2,int ty2,int x3,int y3,int tx3,int ty3,int txn)
{
  int min,mid,max,y,tmp,x,ofs,ttx,tty;
  float dx,dtx,dty,dy,mtx,mty,tx,ty,txi,txf,tyi,tyf,xi,xf;
  tp[0].x=x1; tp[0].y=y1; tp[0].tx=tx1; tp[0].ty=ty1;
  tp[1].x=x2; tp[1].y=y2; tp[1].tx=tx2; tp[1].ty=ty2;
  tp[2].x=x3; tp[2].y=y3; tp[2].tx=tx3; tp[2].ty=ty3;

  if(tp[0].y<tp[1].y) min=0; else min=1;
  if(tp[2].y<tp[min].y) min=2;
  if(tp[0].y>tp[1].y) max=0; else max=1;
  if(tp[2].y>tp[max].y) max=2;
  mid=3-min-max;

  Tscan(tp[min].x,tp[min].y,tp[min].tx,tp[min].ty,tp[max].x,tp[max].y,tp[max].tx,tp[max].ty,1);
  Tscan(tp[min].x,tp[min].y,tp[min].tx,tp[min].ty,tp[mid].x,tp[mid].y,tp[mid].tx,tp[mid].ty,2);
  Tscan(tp[mid].x,tp[mid].y,tp[mid].tx,tp[mid].ty,tp[max].x,tp[max].y,tp[max].tx,tp[max].ty,2);

  for(y=tp[min].y;y<tp[max].y;y++) {
    if (Tedge1[y].x<Tedge2[y].x) {
      xi=Tedge1[y].x;
      xf=Tedge2[y].x;
      txi=Tedge1[y].u;
      txf=Tedge2[y].u;
      tyi=Tedge1[y].v;
      tyf=Tedge2[y].v;
    } else {
      xi=Tedge2[y].x;
      xf=Tedge1[y].x;
      txi=Tedge2[y].u;
      txf=Tedge1[y].u;
      tyi=Tedge2[y].v;
      tyf=Tedge1[y].v;
    }
    dx=xf-xi; dtx=txf-txi; dty=tyf-tyi;
   if(dx!=0) {
    mtx=dtx/dx; mty=dty/dx;
    tx=txi; ty=tyi;
    for(x=xi;x<xf;x++) {
      ofs=ceil(ty)*64+ceil(tx);
      Virtual[x][y]=textable[ofs+(txn-1)*4096];
      tx+=mtx; ty+=mty;
    }
   }
  }
}

void scan(int xi, int yi, int xf, int yf, int e)
{
  int y;
  float m,xx,dy,dx;

  dy=yf-yi; dx=xf-xi;
  if (dy!=0)
  {
    xx=xi;
    m=dx/dy;
    for(y=yi;y<=yf;y++) {
      if(e==1) edge1[y]=ceil(xx); else edge2[y]=ceil(xx);
      xx+=m;
    }
  }
}

void Tscan(int xi, int yi,int txi, int tyi, int xf, int yf,int txf, int tyf, int e)
{
  int y;
  float m,xx,dy,dx,dtx,dty,mtx,mty,tx,ty;

  dy=yf-yi; dx=xf-xi;
  dtx=txf-txi; dty=tyf-tyi;
  if (dy!=0)
  {
    xx=xi; tx=txi; ty=tyi;
    m=dx/dy; mtx=dtx/dy; mty=dty/dy;
    for(y=yi;y<=yf;y++) {
      if(e==1) {
	Tedge1[y].x=ceil(xx);
	Tedge1[y].u=ceil(tx);
	Tedge1[y].v=ceil(ty);
      } else {
	Tedge2[y].x=ceil(xx);
	Tedge2[y].u=ceil(tx);
	Tedge2[y].v=ceil(ty);
      }
      xx+=m; tx+=mtx; ty+=mty;
    }
  }
}

void setVGApalette(unsigned char *buffer)
{
  regs.x.ax=0x1012;
  segread(&inreg);
  inreg.es=inreg.ds;
  regs.x.bx=0;
  regs.x.cx=256;
  regs.x.dx=(int)&buffer[0];
  int86x(0x10,&regs,&regs,&inreg);
}

void gotoxy(int x, int  y)
{
  regs.h.ah=2;
  regs.h.bh=0;
  regs.h.dh=y-1;
  regs.h.dl=x-1;
  int86(0x10,&regs,&regs);
}

void setmode(int mode)
{
  if(mode > 0x32)
  {
    active_bank=0;
    regs.x.ax=0x6F05;
    regs.h.bl=mode;
    int86(0x10,&regs,&regs);
    outpw(0x3C4,0xEA06);
  }
  else
  {
    regs.h.ah=0;
    regs.h.al=mode;
    int86(0x10,&regs,&regs);
  }
}

void plotasm(int x, int y, unsigned char col)
{
  asm {
	push ds;
	push es;
	mov ax, 0xA000;
	mov es, ax;
	mov bx, [x];
	mov dx, [y];
	push bx;
	mov bx, dx;
	mov dh, dl;
	xor dl, dl;
	shl bx, 6;
	add dx, bx;
	pop bx;
	add bx, dx;
	mov di, bx;
	xor al, al;
	mov ah, [col];
	mov es:[di], ah;

	pop es;
	pop ds;
  }
}

void HLine(int y, int xi, int xf, unsigned char col)
{
  asm {
      mov   ax, 0xa000
      mov   es, ax
      mov   ax, [xi]
      mov   bx, [y]
      mov   cx, [xf]
      sub   cx, ax
      mov   di, ax
      mov   dx, bx
      shl   bx, 8
      shl   dx, 6
      add   dx, bx
      add   di, dx
      mov   al, [col]
      rep   stosb
  }
}

int point(int x, int y)
{
  unsigned char col;
  asm {
	push ds;
	push es;
	mov ax, 0xA000;
	mov es, ax;
	mov bx, [x];
	mov dx, [y];
	push bx;
	mov bx, dx;
	mov dh, dl;
	xor dl, dl;
	shl bx, 6;
	add dx, bx;
	pop bx;
	add bx, dx;
	mov di, bx;
	mov ax, es:[di];
	mov [col], al;
	pop es;
	pop ds;
  }
  return(col);
}


void cls(int color)
{
  union REGS regs;
  regs.x.ax = 0x600;
  regs.x.cx = 0;
  regs.x.dx = 0x184F;
  regs.h.bh = color;
  int86(0x10,&regs,&regs);
}

void memcopy(int source, int dest)
{
  asm {
	push ds;

	mov ax, [dest];
	mov es, ax;
	mov ax, [source];
	mov ds, ax;
	xor si, si;
	xor di, di;
	mov cx, 16000;
	rep movsw;

	pop ds;
  }
}

void plot(int x, int y, int color)
{
  long int offset;
  char far *address;
  int temp, temp2;

  offset=(long)xres*(long)y+(long)x;
  bank=offset/65536L;
  offset=offset%65536L;
  if(bank!=active_bank)
  {
    active_bank=bank;
    regs.h.ah=bank & 0x01;
    regs.h.al=0xF9;
    outpw(0x3C4,regs.x.ax);
    temp=inpw(0x3CC);
    temp=temp & 0xDF;
    if((bank & 0x02) != 0)
      temp=temp | 0x20;
    outpw(0x3C2,temp);
    outp(0x3C4,0xF6);
    temp=inpw(0x3C5);
    temp=temp & 0xF0;
    temp2=((bank & 0x0C) >> 2) | (bank & 0x0C);
    temp=temp | temp2;
  }
  address=(char far *)(0xA0000000L + offset);
  *address=color;
}