#define TRUE 1
#define FALSE 0

#define TEX_SIZE 64

#define MAX_OBJECTS 33
//#define NROF_SHADES 63
#define MAXLONG 0x7fffffff

#define NEAR_CLIP 10
#define FAR_CLIP 10000
#define VIEWER_DISTANCE 300

#define OBJ_LOADED 1
#define OBJ_VISIBLE 2
#define OBJ_ON 4
#define OBJ_CLIPPED 8
#define OBJ_STATIC 16
#define OBJ_GOURAUD 32

#define POLY_TWOSIDED 1
#define POLY_LAMBERTSHADED 2
#define POLY_GOURAUDSHADED 4
#define POLY_TEXTUREMAPPED 8
#define POLY_PERSPTEXTURED 16
#define POLY_VISIBLE 32
#define POLY_CLIPPED 64

typedef struct {
   int x,y;
} pix;

typedef struct {
   int x,y,c;
} gpix;

typedef struct {
   int x,y,tx,ty;
} tpix;

typedef struct {
   int x,y,z;
} dir;

typedef struct {
   float x,y,z;
   float rx,ry,rz;
   int px,py;
} vertice_3d;

typedef struct {
   int flags;
   char points,color,shade,tmapindx;
   short pindxs[8];
   void *homeobj_p;
   float normal_len;
   int average_z;
} poly_3d;

typedef struct {
   int flags;
   vertice_3d world,orientation;
   dir rotation,oldangle,angle;
   int vertices,normals;
   vertice_3d *vertices_p, *vnormals_p, *transformed_p;
   int polys;
   poly_3d *polys_p;
   pix *projected_p;
   char *vertex_colors_p;
   float max_radius, average_radius;
} object_3d;

typedef struct {
   int objects;
   vertice_3d initpos;
   dir initdir;
} level;

/*object_3d *Object_Address(int obj);

void Set_ViewPoint(vertice_3d *vp);
void Set_ViewDirection(dir *d);
void Set_LightSource(vector_3d *light);

vertice_3d Get_ViewPoint(void);
dir Get_ViewDirection(void);

void Set_Ambience(int amb);*/

void Make_PolyList(void);
void Sort_PolyList(void);
void Draw_PolyList(void);
